=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2007-01-08 07:06:06 +0000
+++ loggerhead/TODO	2007-01-14 23:46:10 +0000
@@ -14,7 +14,3 @@
 * browse view: sort by name, last change?
 
 * something is leaking on www.lag.net/branches
-
-* better logging
-
-* fix diff-key and buttons (look terrible)

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-20 09:29:42 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-01-14 23:46:10 +0000
@@ -46,6 +46,7 @@
         self._branch = branch
         self.log = branch.log
 
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
         z = time.time()

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-24 07:02:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-01-14 23:46:10 +0000
@@ -49,6 +49,7 @@
         self._branch = branch
         self.log = branch.log
         
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
         z = time.time()

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-20 09:29:42 +0000
+++ loggerhead/controllers/inventory_ui.py	2007-01-14 23:46:10 +0000
@@ -46,6 +46,7 @@
         self._branch = branch
         self.log = branch.log
 
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.inventory')
     def default(self, *args, **kw):
         z = time.time()

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2007-01-08 00:00:26 +0000
+++ loggerhead/controllers/revision_ui.py	2007-01-14 23:46:10 +0000
@@ -36,6 +36,7 @@
         self._branch = branch
         self.log = branch.log
 
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
         z = time.time()

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-01-14 05:42:46 +0000
+++ loggerhead/static/css/style.css	2007-01-14 23:46:10 +0000
@@ -443,13 +443,17 @@
 }
 .diff .lineno-skip {
     width: 4em;
-    background-color: #dee7ec; 
+    background-color: #dee7ec;
 }
 .diff .info {
     color: blue;
     background-color: #dee7ec;
     margin-top: 15px;
 }
+/*
+.diff-context-skip {
+    background-color: #dee7ec;
+}*/
 
 
 /* ----- file inventory ----- */

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-01-14 02:00:56 +0000
+++ loggerhead/templates/revision.kid	2007-01-14 23:46:10 +0000
@@ -125,12 +125,22 @@
                     <th class="lineno">old</th> <th></th> <th class="lineno">new</th> <th></th>
                 </tr>
                 <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
-                    <td py:if="line.old_lineno" class="lineno">${line.old_lineno}</td>
-                    <td py:if="not line.old_lineno" class="lineno-skip">${line.old_lineno}</td>
-                    <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
-                    <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                    <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                    <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
+                    <span py:if="line.old_lineno" py:strip="True">
+                        <td class="lineno">${line.old_lineno}</td>
+                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
+                    </span>
+                    <span py:if="not line.old_lineno" py:strip="True">
+                        <td class="lineno-skip">${line.old_lineno}</td>
+                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
+                    </span>
+                    <span py:if="line.new_lineno" py:strip="True">
+                        <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
+                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
+                    </span>
+                    <span py:if="not line.new_lineno" py:strip="True">
+                        <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
+                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
+                    </span>
                 </tr>
                 <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
             </span>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-01-14 01:21:30 +0000
+++ loggerhead/util.py	2007-01-14 23:46:10 +0000
@@ -338,3 +338,18 @@
         return locked
     return _decorator
 
+
+@decorator
+def strip_whitespace(f):
+    def _f(*a, **kw):
+        out = f(*a, **kw)
+        orig_len = len(out)
+        out = re.sub(r'\n\s+', '\n', out)
+        out = re.sub(r'[ \t]+', ' ', out)
+        out = re.sub(r'\s+\n', '\n', out)
+        new_len = len(out)
+        log.debug('Saved %sB (%d%%) by stripping whitespace.',
+                  human_size(orig_len - new_len),
+                  round(100.0 - float(new_len) * 100.0 / float(orig_len)))
+        return out
+    return _f

